import sqlite3

def create_connection(db_file):
    """ create a database connection to the SQLite database
        specified by db_file
    :param db_file: database file
    :return: Connection object or None
    """
    conn = None
    try:
        conn = sqlite3.connect(db_file)
    except Error as e:
        print(e)

    return conn


def create_table(conn):
    """ create a table from the create_table_sql statement
    :param conn: Connection object
    :param create_table_sql: a CREATE TABLE statement
    :return:
    """

    cases_table = """ CREATE TABLE IF NOT EXISTS cases (
                                        id INTEGER PRIMARY KEY AUTOINCREMENT,
                                        as1 INTEGER,
                                        as2 INTEGER,
                                        nb_leg INTEGER,
                                        nb_sus INTEGER,
                                        date TIMESTAMP,
                                        recurrent BOOL,
                                        type VARCHAR(100),
                                        invalid_origin BOOL, 
                                        local BOOL,
                                        nbpaths INTEGER,
                                        attackers VARCHAR(10000),
                                        victims VARCHAR(10000)
                                    ); """

    cases_detail_table = """ CREATE TABLE IF NOT EXISTS cases_detail (
                                        case_id INTEGER,
                                        ts TIMESTAMP,
                                        prefix VARCHAR(100),
                                        aspath VARCHAR(1000),
                                        peer_ip VARCHAR(100),
                                        peer_as INTEGER,
                                        peer_name VARCHAR(1000),
                                        FOREIGN KEY (case_id) REFERENCES cases(id)
                                    ); """


    try:
        c = conn.cursor()
        c.execute(cases_table)
        c.execute(cases_detail_table)
    except Error as e:
        print(e)

if __name__ == "__main__":
    conn = create_connection("db.sql")
    create_table(conn)